#include <conio.h>//textmode, ...
#include <dos.h>//delay
#include <stdlib.h>//NULL, random, ...

#ifndef _Byte_

#define _Byte_
typedef unsigned char Byte;

#endif

class CList {
 struct CItem {
  void *item;
  CItem *prev;
  CItem *next;
 };
 CItem *head;
 int count;
 int actual;
 public:
 CList () { head = NULL; count = 0; }
 ~CList ();
 void InsertLast (void *_item);
 void Delete (void* _item);
 void* Get (int _index);
 void* Get ();
 int GetActual () { return actual; }
 void SetActual (int _act) { actual = _act; }
 int GetCount () { return count; }
};

class CGround {
 int Screen_Segment;
 Byte Screen_startX, Screen_startY, Screen_width, Screen_height;
 Byte sea_color, ground_color, sea_char, ground_char, width, height, actwidth, actstartx;
 Byte min_width, hole_heightl, hole_heightr, min_hole_height;
 float hil, hir, dxl, dxr, dxl0, dxr0;
 int hole_probability;
 char field[67][80][2];
 long track_length;
 char speed, spd, down;
 void Generate ();
 void Paint ();
 public:
 CGround ();
 void Tick ();
 char Free (Byte x, Byte y, Byte dx, Byte dy);
 int GetSSegment () { return Screen_Segment; }
 Byte GetSStartX () { return Screen_startX; }
 Byte GetSStartY () { return Screen_startY; }
 Byte GetSWidth () { return Screen_width; }
 Byte GetSHeight () { return Screen_height; }
 Byte GetField (Byte x, Byte y, char c) { return field[y][x][c]; }
 void SetField (Byte x, Byte y, Byte s, Byte col) { field[y][x][0] = s; field[y][x][1] = col; }
 Byte GetHeight () { return height; }
 Byte GetWidth () { return actwidth; }
 Byte GetStartX () { return actstartx; }
 Byte GetSeaColor () { return sea_color; }
 Byte GetSeaShape () { return sea_char; }
 Byte GetGroundColor () { return ground_color; }
 Byte GetGroundShape () { return ground_char; }
 char Down () { return down; }
 long GetTrackLength () { return track_length; }
};

class CFighter;

class CEnemy {
 protected:
  Byte SizeX, SizeY;
  struct tBody {
   Byte shape, color;
  } **Body;
  int posX, posY;
  CGround *ground;
  CList *enemy_list;
  CFighter* fighter;
  static int enemy_probability;
  int shoot_probability;
  char state, speed, spd, dir, points;
  virtual void Paint ();
  virtual void Clear ();
 public:
  CEnemy (CGround *ground, CList* _enemy_list, CFighter* _fighter);
  ~CEnemy ();
  static void Up_Probability ();
  virtual void Tick () = 0;
  virtual char Create ();
  virtual void Destroy ();
  virtual void Move () = 0;
  virtual void State () = 0;
  virtual void Shoot ();
  virtual char IsBody (int _x, int _y);
  virtual void Kill (char by_fighter);
};

int CEnemy::enemy_probability = 40;
void CEnemy::Up_Probability () { enemy_probability--; }

class CEnemy1 : public CEnemy {
 public:
  CEnemy1 (CGround *ground, CList* _enemy_list, CFighter* _fighter);
  void Tick ();
  void Move () {}
  void State ();
  void Kill (char by_figter) {}
};

class CEnemy2 : public CEnemy {
 public:
  CEnemy2 (CGround *ground, CList* _enemy_list, CFighter* _fighter);
  void Tick ();
  void Move () {}
  void State () {}
};

class CEnemy3 : public CEnemy {
 public:
  CEnemy3 (CGround *ground, CList* _enemy_list, CFighter* _fighter);
  void Tick ();
  void Move ();
  void State ();
};

class CEnemy4 : public CEnemy {
 public:
  CEnemy4 (CGround *ground, CList* _enemy_list, CFighter* _fighter);
  void Tick ();
  void Move ();
  void State ();
};

class CShot {
 private:
  struct tBody {
   Byte shape, color;
  } Body;
  int posX, posY;
  CGround *ground;
  CList *enemy_list;
  CList* shot_list;
  CFighter* fighter;
  char dir;
  void Paint ();
 public:
  CShot (int _posX, int _posY, char _dir, CGround *ground, CList* _enemy_list, CList* _shot_list, CFighter* _fighter);
  void Clear ();
  void Tick ();
  char Create ();
  void Destroy ();
  char Hit ();
  char IsBody (int _x, int _y);
};

class CFighter {
 protected:
  Byte SizeX, SizeY;
  struct tBody {
   Byte shape, color;
  } **Body;
  int posX, posY;
  CGround *ground;
  CList *enemy_list;
  char tomove, toshoot;
  long shooted;
  long points;
  void Paint ();
  void Clear ();
  void DoShoot ();
 public:
  CFighter (CGround *ground, CList* _enemy_list);
  ~CFighter ();
  void Tick ();
  void Create ();
  void Destroy ();
  void Move (char dir) { tomove += dir; }
  void Shoot () { toshoot = 1; }
  char Hit ();
  char IsBody (int _x, int _y);
  void AddPoints (char _points) { shooted++; points += _points; }
  long GetPoints () { return points; }
  long GetShootedCount () { return shooted; }
};

class CScoreTable {
 CGround *ground;
 CFighter* fighter;
 public:
 CScoreTable (CGround *_ground, CFighter* _fighter);
 void Update ();
};