#include <dos.h>

#ifdef __cplusplus
 #define __CPPARGS ...
#else
 #define __CPPARGS
#endif

class CKeyBoard {

 //Key codes
 static int
 Right_Arrow_Pressed,
 Right_Arrow_Released,
 Left_Arrow_Pressed,
 Left_Arrow_Released,
 Space_Pressed,
 Space_Released,
 Enter_Pressed,
 Enter_Released,
 Esc_Pressed;

 static int ScanCode;
 static int Keyb_Int;
 static void InitKeys ();
 static void interrupt (*OldVect) (__CPPARGS);
 static void interrupt Keyb_Proc (__CPPARGS);
 static void KeyCheck ();
 public:

 //Keys
 static char
 RightArrow,
 LeftArrow,
 Space,
 Enter,
 Esc;

 CKeyBoard ();
 ~CKeyBoard ();
 static void Release ();
};

//Key codes
int
CKeyBoard::Right_Arrow_Pressed,
CKeyBoard::Right_Arrow_Released,
CKeyBoard::Left_Arrow_Pressed,
CKeyBoard::Left_Arrow_Released,
CKeyBoard::Space_Pressed,
CKeyBoard::Space_Released,
CKeyBoard::Enter_Pressed,
CKeyBoard::Enter_Released,
CKeyBoard::Esc_Pressed;

//Keys
char
CKeyBoard::RightArrow,
CKeyBoard::LeftArrow,
CKeyBoard::Space,
CKeyBoard::Enter,
CKeyBoard::Esc;

int CKeyBoard::ScanCode;
int CKeyBoard::Keyb_Int;

void interrupt (*CKeyBoard::OldVect) (__CPPARGS);

void CKeyBoard::InitKeys ()
{
 int rel = 0x80;
 Right_Arrow_Pressed = 77;
 Right_Arrow_Released = Right_Arrow_Pressed + rel;
 Left_Arrow_Pressed = 75;
 Left_Arrow_Released = Left_Arrow_Pressed + rel;
 Space_Pressed = 57;
 Space_Released = Space_Pressed + rel;
 Enter_Pressed = 28;
 Enter_Released = Enter_Pressed + rel;
 Esc_Pressed = 1;
}

CKeyBoard::CKeyBoard ()
{
 RightArrow = 0;
 LeftArrow = 0;
 Space = 0;
 Enter = 0;
 Esc = 0;
 Keyb_Int = 9;
 InitKeys ();
 OldVect = getvect (Keyb_Int);
 setvect (Keyb_Int, Keyb_Proc);
}

CKeyBoard::~CKeyBoard ()
{
 setvect (Keyb_Int, OldVect);
}

void interrupt CKeyBoard::Keyb_Proc (__CPPARGS)
{
 register char x;
 ScanCode = inp (0x60);
 x = inp(0x61);
 outp (0x61, (x | 0x80));
 outp (0x61, x);
 outp (0x20, 0x20);
 KeyCheck ();
}

void CKeyBoard::KeyCheck ()
{
 if (ScanCode == Right_Arrow_Pressed) RightArrow = 1;
 if (ScanCode == Right_Arrow_Released) RightArrow = 0;
 if (ScanCode == Left_Arrow_Pressed) LeftArrow = 1;
 if (ScanCode == Left_Arrow_Released) LeftArrow = 0;
 if (ScanCode == Space_Pressed) Space = 1;
 if (ScanCode == Space_Released) Space = 0;
 if (ScanCode == Enter_Pressed) Enter = 1;
 if (ScanCode == Enter_Released) Enter = 0;
 if (ScanCode == Esc_Pressed) Esc = 1;
}

void CKeyBoard::Release ()
{
 RightArrow = 0;
 LeftArrow = 0;
 Space = 0;
 Enter = 0;
 Esc = 0;
}